package edu.cmu.ece.drawe3.tracking;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

import android.opengl.Matrix;

public class MarkerCfg
{
	private float[] T;
	
	public MarkerCfg(float[] T)
	{
		assert(T.length == 16);
		this.T = T;
	}
	
	public float[] getPosition(float[] pose)
	{
		float[] res = new float[16];
		Matrix.multiplyMM(res, 0, T, 0, pose, 0);
		return res;
	}
	
	public static Map<Integer, MarkerCfg> load(URL url)
	{
		Map<Integer, MarkerCfg> cfg = new HashMap<Integer, MarkerCfg>();
		try {
			HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
			try {
				Scanner in = new Scanner(urlConnection.getInputStream());
				
				while(in.hasNextInt())
				{
					int id = in.nextInt();
					float[] t = new float[16];
					for(int i = 0; i < 16; i++)
						t[i] = in.nextFloat();
					cfg.put(id, new MarkerCfg(t));
				}
			} finally {
				urlConnection.disconnect();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("Loaded " + cfg.size() + " markers");
		return cfg;
	}
}