package edu.cmu.ece.drawe3.tracking.nyartk;

import jp.nyatla.nyartoolkit.NyARException;
import jp.nyatla.nyartoolkit.core.param.NyARParam;
import jp.nyatla.nyartoolkit.core.squaredetect.NyARSquare;
import jp.nyatla.nyartoolkit.core.transmat.NyARTransMatResult;
import jp.nyatla.nyartoolkit.jogl.utils.NyARGLUtil;
import jp.nyatla.nyartoolkit.nyidmarker.data.INyIdMarkerData;
import jp.nyatla.nyartoolkit.nyidmarker.data.NyIdMarkerDataEncoder_RawBit;
import jp.nyatla.nyartoolkit.nyidmarker.data.NyIdMarkerData_RawBit;
import jp.nyatla.nyartoolkit.processor.SingleNyIdMarkerProcesser;

class MarkerProcessor extends SingleNyIdMarkerProcesser
{	
	public double[] gltransmat=new double[16];
	public int current_id=-1;

	public MarkerProcessor(NyARParam i_cparam,int i_width,int i_raster_format) throws NyARException
	{
		super();
		initInstance(i_cparam,new NyIdMarkerDataEncoder_RawBit(),i_width,i_raster_format);
	}
	
	protected void onEnterHandler(INyIdMarkerData i_code)
	{
		NyIdMarkerData_RawBit code=(NyIdMarkerData_RawBit)i_code;
		if(code.length>4){
			this.current_id=-1;//undefined_id
		}else{
			this.current_id=0;
			for(int i=0;i<code.length;i++){
				this.current_id=(this.current_id<<8)|code.packet[i];
			}
		}
	}
	
	protected void onLeaveHandler()
	{
		this.current_id=-1;
	}
	
	protected void onUpdateHandler(NyARSquare i_square, NyARTransMatResult result)
	{
		try{
			NyARGLUtil.toCameraViewRH(result, 1, this.gltransmat);
		}catch(Exception e){
			e.printStackTrace();
		}		
	}
	
	public double[] getGLTransform()
	{
		return this.gltransmat;
	}
}